local ret = ... or {};        
ret.RedirTable =
{                 
	Key1		= "1";
	Key2		= "2";
	Key3		= "3";
	Key4        = "4";
	Key5		= "5";
	Key6		= "6";
	Key7		= "7";
};

local OldRedir = ret.Redir;
ret.Redir = function(sButton, sElement)
	-- sButton, sElement = OldRedir(sButton, sElement);

	-- Instead of separate hold heads, use the tap note graphics.

	
	if string.find(sElement, "Head") or string.find(sElement, "Tail") or sElement == "Tap Fake" then
		sElement = "Tap Note";
	end
  
	if sElement == "Hold Body Inactive"
	then
		sElement = "Hold Body Active";
	end                                   
	  
  
               	
	sButton = ret.RedirTable[sButton];

	return sButton, sElement;
end

-- local OldRedir = ret.Redir;
-- ret.Redir = function(sButton, sElement)
	-- sButton = ret.RedirTable[sButton];
	-- return sButton, sElement;
-- end

-- To have separate graphics for each hold part:
local OldRedir = ret.Redir;
ret.Redir = function(sButton, sElement)
	-- Redirect non-hold, non-roll parts.
	if string.find(sElement, "hold") or string.find(sElement, "roll") then
		return sButton, sElement;
	end
	return OldRedir(sButton, sElement);
end

--[[
local OldFunc = ret.Load;
function ret.Load()
	local t = OldFunc();

	-- The main "Explosion" part just loads other actors; don't rotate
	-- it.  The "Hold Explosion" part should not be rotated.
	if Var "Element" == "Explosion" or
	   Var "Element" == "Roll Explosion" then
		t.BaseRotationZ = nil;
	end
	return t;
end
]]

local OldFunc = ret.Load;
function ret.Load()
	local t = OldFunc();

	--Explosion should not be rotated; it calls other actors.
	if Var "Element" == "Explosion"	then
		t.BaseRotationZ = nil;
	end
	return t;
end

ret.PartsToRotate =
{
	["Receptor"] = true,
	["Go Receptor"] = true,
	["Ready Receptor"] = true,
	["Tap Note"] = true,
	["Tap Fake"] = true,
	["Tap Lift"] = true,
	["Hold Head Active"] = true,
	["Hold Head Inactive"] = true,
	["Roll Head Active"] = true,
	["Roll Head Inactive"] = true,
	["Hold Explosion"] = true,
};
ret.Rotate =
{
	Up = 0,
	Down = 0,
	Left = 0,
	Right = 0,
	UpLeft = 0,
	UpRight = 0,
};

--
-- If a derived skin wants to have separate UpLeft graphics,
-- use this:
--
-- ret.RedirTable.UpLeft = "UpLeft";
-- ret.RedirTable.UpRight = "UpLeft";
-- ret.Rotate.UpLeft = 0;
-- ret.Rotate.UpRight = 90;
--
ret.Blank =
{
	["Tap Explosion Bright"] = true,
	["Tap Explosion Dim"] = true,
	["Hold Topcap Active"] = true,
	["Hold Topcap Inactive"] = true,
	["Roll Topcap Active"] = true,
	["Roll Topcap Inactive"] = true,
	["Hold Bottomcap Active"] = true,
	["Hold Bottomcap Inactive"] = true,
	["Roll Bottomcap Active"] = true,
	["Roll Bottomcap Inactive"] = true,
	--["Hold Tail Active"] = true,    
	--["Roll Tail Active"] = true,
	["Roll Explosion"] = true,
};

return ret;
